package osalpr1;


import jade.core.AID;
import jade.core.Agent;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPANames;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import jade.core.behaviours.CyclicBehaviour;
import jade.core.behaviours.OneShotBehaviour;
import jade.core.behaviours.TickerBehaviour;
import jade.core.behaviours.WakerBehaviour;

import java.util.Iterator;
import java.util.StringTokenizer;

import osalpr1.OurSoldier.DeferredCallForAmmo;
import osalpr1.OurSoldier.DeferredCallForMedic;
import osalpr1.OurSoldier.GetPals;
import osalpr1.OurSoldier.InitOperationAgain;
import osalpr1.OurSoldier.LogState;
import osalpr1.OurSoldier.RecepMsg;
import osalpr1.OurSoldier.SendFlagPos;
import osalpr1.OurSoldier.calculatePath;





import es.upv.dsic.gti_ia.jgomas.CMedic;
import es.upv.dsic.gti_ia.jgomas.CSoldier;
import es.upv.dsic.gti_ia.jgomas.CPack;
import es.upv.dsic.gti_ia.jgomas.CSight;
import es.upv.dsic.gti_ia.jgomas.CTask;
import es.upv.dsic.gti_ia.jgomas.CTerrainMap;
import es.upv.dsic.gti_ia.jgomas.Vector3D;
/*if ( m_eTeam == eTeam ){
//log.writeLine("soy clase :"+m_eClass);
//log.writeLine("veo tipo :"+s.getType());
}*/
/*
int currentTask = m_CurrentTask.getType();
switch (operationState){
case GOING_HELL:
	switch (soldierState){
	case AT_WORK:
		switch (currentTask){
		case CTask.TASK_WALKING_PATH:
			break;
		default:
		}
		break;
	case TAKING_BREAK:
		switch (currentTask){
		case CTask.TASK_WALKING_PATH:
			break;
		default:
		}
		break;
	default:		
	}
	break;
case GOING_HOME:
	switch (soldierState){
	case AT_WORK:
		switch (currentTask){
		case CTask.TASK_WALKING_PATH:
			break;
		default:
		}
		break;
	case TAKING_BREAK:
		switch (currentTask){
		case CTask.TASK_WALKING_PATH:
			break;
		default:
		}break;
	default:		
	}
	break;
default:			
}
*/



public class OurMedic extends CMedic {
//A1:osalpr1.OurSoldier(ALLIED) A2:osalpr1.OurSoldier(ALLIED) A3:osalpr1.OurSoldier(ALLIED) A4:osalpr1.OurSoldier(ALLIED)	

	CAstar pathFinder;
	Vector3D[] homePath;
	Vector3D[] hellPath;
	Vector3D[] rearPath;
	String team;
	Logger log;
	//private static final String password = "_EstoEsUnInfierno";
	private static final String GOT_FLAG = "GF";
	private static final String LOST_FLAG = "LF";
	private long NO_FLAG_NEWS_TIME;
	private static final String WAIT = "W";
	private static final String REAR_POS = "RP";
	private static final String FORE_POS = "FP";
	private DFAgentDescription[] pals;
	//private DFAgentDescription dfd = new DFAgentDescription();
	//private Vector3D forePos; //Posicin ms adelantada de mi equipo
	//private Vector3D rearPos; //Posicin ms atrasada de mi equipo
	//private double foreDistance; //Distancia al enemigo mas cercano
	private static final int MAX_DISTANCE = 10000;
	private static final long GOT_FLAG_LAP = 500l;
	private int hits = 0;
	private static final int HIT_LOOP = 5;
	private static final int GOING_HELL = 1;
	private static final int GOING_HOME = 2;
	private static final int TAKING_BREAK = 3;
	private static final int AT_WORK = 5;
	private int operationState;
	private int soldierState;
	private int toHellPathIndex;
	boolean needMedicPacks;
	boolean needAmmoPacks;
	private Vector3D lastPos;
	private boolean gotFlag;
	InitOperationAgain iab = null;
	private long SHAPE_TIME;
	private static final int BREAK_LENGTH = 0;
	private boolean medicAtView;
	private boolean fieldOpAtView;
	private int lastValidRearIndex;
	
	//DEFENSA
	double INNER_RADIUS = 20;
	double OUTER_RADIUS = 40;
	double ACTION_RADIUS = 100;
	private static final String ENEMY_POS = "EP";
	
	protected void setup() {
		//Hay que aadir los servicios antes del setup o no van.
		//Soy un compaero
		AddServiceType("pal");
		super.setup();
		SetUpPriorities();
		log  = new Logger(getAID().getLocalName());
		//Averiguo en qu bando estoy
		if (m_eTeam == TEAM_ALLIED) {
			team = "_Allied";
			//Pido la ruta de ida y vuelta al objetivo
			addBehaviour(new calculatePath());				
			//Crea un comportamiento que recuenta compaeros vivos
			addBehaviour(new GetPals(this, 2000l));
			//Crea un comportamiento para recibir mensajes
			addBehaviour(new RecepMsg());
			//forePos = new Vector3D(m_Movement.getPosition());
			//rearPos = new Vector3D(m_Movement.getPosition());
			//foreDistance = MAX_DISTANCE;
			operationState = GOING_HELL;
			soldierState = AT_WORK;
			rearPath = new Vector3D[5];
			m_Threshold.SetAmmo(75);
			m_Threshold.SetHealth(75);
			lastPos = new Vector3D(m_Movement.getPosition());
			addBehaviour(new LogState(this, 500l));
			gotFlag = false;
			SHAPE_TIME = System.currentTimeMillis() + (3 * 1000);
			medicAtView = false;
			needMedicPacks = false;
			fieldOpAtView = false;
			needAmmoPacks = false;
			lastValidRearIndex = -1;
		}
		else {
			team = "_Axis";
			//Pido la ruta de ida y vuelta al objetivo
			addBehaviour(new calculatePath());
			//Crea un comportamiento que recuenta compaeros vivos
			addBehaviour(new GetPals(this, 2000l));
			addBehaviour(new RecepMsg());
			m_Threshold.SetAmmo(75);
			m_Threshold.SetHealth(75);
			lastPos = new Vector3D(m_Movement.getPosition());
			addBehaviour(new LogState(this, 500l));
		}
	}
	public class LogState extends TickerBehaviour{
		public LogState(Agent arg0, long arg1) {
			super(arg0, arg1);
		}
		protected void onTick() {	
			log.writeLine("opst :"+operationState+" slst :"+soldierState+" ct:"+m_CurrentTask.getType());
			log.writeLine("h :"+GetHealth()+" a:"+GetAmmo());
			if (lastPos.x == m_Movement.getPosition().x && lastPos.z == m_Movement.getPosition().z){
				log.writeLine("soldado parado");
			}
			else{
				lastPos = new Vector3D(m_Movement.getPosition());
			}
		}	
	}
	public class InitOperationAgain extends WakerBehaviour{
		public InitOperationAgain(Agent agent,long time){
			super(agent,time);
		}
		protected void handleElapsedTimeout(){
			int my_toHomePathIndex;
			String sNewPosition;
			int currentTask = m_CurrentTask.getType();
			log.writeLine("InitOperationAgain!!!");
			
			int toHomePathIndex;
			switch (operationState){
			case GOING_HELL:
				switch (soldierState){
				case AT_WORK:
					switch (currentTask){
					case CTask.TASK_WALKING_PATH:
						break;
					default:
						break;
					}
					break;
				case TAKING_BREAK:
					switch (currentTask){
					case CTask.TASK_WALKING_PATH:
						//El soldado est de permiso.
						//Dejamos que lo termine ya que es posible que vaya a por packs sanitarios o de municion
						break;
					default:
						//No se cmo lleg donde estoy
						//La manera segura de proceder es pedir una ruta a casa al CAstar
						//sin embargo, podemos suponer (al 90%) que lo que ocurri es que la rearPath se finaliz 
						//de modo que el soldado est en algn sitio cerca del punto final de rearPath.
						//Averiguo qu ndice del camino homePath se corresponde en coordenadas con el ndice del camino rearPath en el que estoy.
						toHomePathIndex = hellPath.length - (toHellPathIndex - (lastValidRearIndex) - 1) - 2;
						log.writeLine("Uso toHellPathIndex:"+toHellPathIndex);
						if (toHomePathIndex<0){
							toHomePathIndex = 0;
						}
						m_AStarPath = homePath;
						m_iAStarPathIndex = toHomePathIndex;
						sNewPosition = " ( " + m_AStarPath[m_iAStarPathIndex].x + " , " + 0 + " , " + m_AStarPath[m_iAStarPathIndex].z + " ) "; 
						AddTask(CTask.TASK_WALKING_PATH, getAID(), sNewPosition, m_TaskPriority[CTask.TASK_WALKING_PATH]);
						lastValidRearIndex = -1;
						operationState = GOING_HOME;
						soldierState = AT_WORK;
						log.writeLine("CHANGE STATE 1");
						break;
					}
					break;
				default:
					//Put code here
					break;
				}
				break;
			case GOING_HOME:
				switch (soldierState){
				case AT_WORK:
					switch (currentTask){
					case CTask.TASK_WALKING_PATH:
						//El soldado est volviendo a casa y por lo tanto direccin contraria
						my_toHomePathIndex = m_iAStarPathIndex;
						m_AStarPath = hellPath;
						m_iAStarPathIndex = homePath.length - my_toHomePathIndex - 2;
						if (m_iAStarPathIndex<0){
							m_iAStarPathIndex = 0;
						}
						else{
							m_iAStarPathIndex++;
						}
						sNewPosition = " ( " + m_AStarPath[m_iAStarPathIndex].x + " , " + 0 + " , " + m_AStarPath[m_iAStarPathIndex].z + " ) "; 
						AddTask(CTask.TASK_WALKING_PATH, getAID(), sNewPosition, m_TaskPriority[CTask.TASK_WALKING_PATH]);
						lastValidRearIndex = -1;
						operationState = GOING_HELL;
						soldierState = AT_WORK;
						log.writeLine("CHANGE STATE 2");
						break;
					default:
						//No se cmo lleg donde estoy
						//La manera segura de proceder es pedir una ruta a casa al CAstar
						//sin embargo, podemos suponer (al 90%) que lo que ocurri es que la homePath se finaliz 
						//de modo que el soldado est en algn sitio cerca del punto final de homePath.
						my_toHomePathIndex = homePath.length - 1;												
						m_AStarPath = hellPath;
						m_iAStarPathIndex = 0;
						sNewPosition = " ( " + m_AStarPath[m_iAStarPathIndex].x + " , " + 0 + " , " + m_AStarPath[m_iAStarPathIndex].z + " ) "; 
						AddTask(CTask.TASK_WALKING_PATH, getAID(), sNewPosition, m_TaskPriority[CTask.TASK_WALKING_PATH]);
						lastValidRearIndex = -1;
						operationState = GOING_HELL;
						soldierState = AT_WORK;
						break;
					}
					break;
				case TAKING_BREAK:
					switch (currentTask){
					case CTask.TASK_WALKING_PATH:
						//No definimos nada volviendo a casa
						//Esta situacin es imposible (al 90%). No hago nada.
						break;
					default:
						//No definimos nada volviendo a casa
						//Esta situacin es imposible (al 90%). No hago nada.
						break;
					}
					break;
				default:
					//Put code here
					break;
				}
				break;
			default:
				//Put code here
				break;
			}	
		}
	}
	
	
	
	//Comportamiento encargado de recibir y procesar mensajes
	public class RecepMsg extends CyclicBehaviour{
		public void action() {
			MessageTemplate template = MessageTemplate.or(	MessageTemplate.MatchPerformative(ACLMessage.REQUEST),
					MessageTemplate.MatchPerformative(ACLMessage.INFORM));
			ACLMessage msg = receive(template);
			if (msg != null) {
				if (m_eTeam == TEAM_ALLIED) {
					if (msg.getConversationId().equals(WAIT)){
						log.writeLine("WAIT recibido");
						AddTask(CTask.TASK_STOP_WALKING, getAID(), msg.getContent(), m_CurrentTask.getPriority() + 1);
						return;
					}
					if (msg.getConversationId().equals(LOST_FLAG)){
						log.writeLine("LOST_FLAG received");
						if (iab == null){
							iab = new InitOperationAgain(this.myAgent,NO_FLAG_NEWS_TIME);
							addBehaviour(iab);
						}
						return;
					}
					if (msg.getConversationId().equals(GOT_FLAG)){
						log.writeLine("GOT_FLAG received");
						
						if (iab!=null){
							this.myAgent.removeBehaviour(iab);
							iab = null;
						}
						if (gotFlag) return;
						StringTokenizer tokens = new StringTokenizer(msg.getContent());
						int toHomePathIndex = Integer.parseInt(tokens.nextToken());
						int my_toHomePathIndex;
						String sNewPosition;
						int currentTask = m_CurrentTask.getType();
						switch (operationState){
						case GOING_HELL:
							switch (soldierState){
							case AT_WORK:
								switch (currentTask){
								case CTask.TASK_WALKING_PATH:
									//Me pilla en direccin contraria, hay que averiguar si me lo cruzar o me lo he cruzado ya.
									//Conversion de indice de camino de vuelta a ida								
									int toHellPathIndexEQ = homePath.length - toHomePathIndex - 2;								
									if (m_iAStarPathIndex>toHellPathIndexEQ){
										//Me lo he cruzado
										//hay que cambiar de rumbo y atajar
										m_AStarPath = homePath;
										m_iAStarPathIndex = toHomePathIndex;
										sNewPosition = " ( " + m_AStarPath[m_iAStarPathIndex].x + " , " + 0 + " , " + m_AStarPath[m_iAStarPathIndex].z + " ) "; 
										AddTask(CTask.TASK_WALKING_PATH, getAID(), sNewPosition, m_TaskPriority[CTask.TASK_WALKING_PATH]);
										operationState = GOING_HOME;
										soldierState = AT_WORK;
										log.writeLine("CHANGE STATE 3");
									}
									else{
										//No me he cruzado todavia con el portador de la bandera, pero voy a hacerlo. No hago nada
									}
									break;
								default:
									//No s cmo lleg dnde estoy
									//sin embargo, podemos suponer (al 90%) que lo que ocurri es que la hellPath se finaliz 
									//de modo que el soldado est en algn sitio cerca del punto final de hellPath. 
									m_AStarPath = homePath;
									m_iAStarPathIndex = 0;
									sNewPosition = " ( " + m_AStarPath[m_iAStarPathIndex].x + " , " + 0 + " , " + m_AStarPath[m_iAStarPathIndex].z + " ) "; 
									AddTask(CTask.TASK_WALKING_PATH, getAID(), sNewPosition, m_TaskPriority[CTask.TASK_WALKING_PATH]);

									operationState = GOING_HOME;
									soldierState = AT_WORK;
									log.writeLine("CHANGE STATE 4");
									break;
								}
								break;
							case TAKING_BREAK:
								switch (currentTask){
								case CTask.TASK_WALKING_PATH:
									//El soldado est de permiso y por lo tanto en buena direccin.
									//Hay que saber si esta detrs o delante del portador para recolocarlo en este caso
									//Averiguo qu ndice del camino homePath se corresponde en coordenadas con el ndice del camino rearPath al que voy.
									my_toHomePathIndex = hellPath.length - (toHellPathIndex - m_iAStarPathIndex - 1) - 2;
									log.writeLine("Uso toHellPathIndex:"+toHellPathIndex);
									//Averiguo a que ndice del camino al objetivo corresponde el ndice del camino a casa en el que esta el portador								
									if (toHomePathIndex-my_toHomePathIndex>=0){								
										//El soldado est bien situado slo hay que darle la ruta a casa
										m_AStarPath = homePath;
										m_iAStarPathIndex = my_toHomePathIndex;
										sNewPosition = " ( " + m_AStarPath[m_iAStarPathIndex].x + " , " + 0 + " , " + m_AStarPath[m_iAStarPathIndex].z + " ) "; 
										AddTask(CTask.TASK_WALKING_PATH, getAID(), sNewPosition, m_TaskPriority[CTask.TASK_WALKING_PATH]);
										lastValidRearIndex = -1;
										operationState = GOING_HOME;
										soldierState = AT_WORK;
										log.writeLine("CHANGE STATE 5");
									}
									else{
										//El soldado est mal situado hay que hacer que cambie de direccin para que se cruce con el portador
										//Sin embargo esto pasara por si solo en cuanto acabe su permiso. No hago nada.
										/*
									m_AStarPath = hellPath;
									m_iAStarPathIndex = toHellPathIndex - m_iAStarPathIndex;
									sNewPosition = " ( " + m_AStarPath[m_iAStarPathIndex].x + " , " + 0 + " , " + m_AStarPath[m_iAStarPathIndex].z + " ) "; 
									AddTask(CTask.TASK_WALKING_PATH, getAID(), sNewPosition, m_TaskPriority[CTask.TASK_WALKING_PATH]);
									operationState = GOING_HELL;
									soldierState = AT_WORK;
									log.writeLine("CHANGE STATE 6");
										 */
									}
									break;
								default:
									//No se cmo lleg donde estoy
									//La manera segura de proceder es pedir una ruta a casa al CAstar
									//sin embargo, podemos suponer (al 90%) que lo que ocurri es que la rearPath se finaliz 
									//de modo que el soldado est en algn sitio cerca del punto final de rearPath.
									//El soldado est de permiso y por lo tanto en buena direccin.
									//Hay que saber si esta detrs o delante del portador para recolocarlo en este caso
									//Averiguo qu ndice del camino homePath se corresponde en coordenadas con el ndice del camino rearPath al que voy.
									my_toHomePathIndex = hellPath.length - (toHellPathIndex - (lastValidRearIndex) - 1) - 2;
									log.writeLine("Uso toHellPathIndex:"+toHellPathIndex);
									//Averiguo a que ndice del camino al objetivo corresponde el ndice del camino a casa en el que esta el portador								
									if (toHomePathIndex-my_toHomePathIndex>=0){								
										//El soldado est bien situado slo hay que darle la ruta a casa
										m_AStarPath = homePath;
										m_iAStarPathIndex = my_toHomePathIndex;
										sNewPosition = " ( " + m_AStarPath[m_iAStarPathIndex].x + " , " + 0 + " , " + m_AStarPath[m_iAStarPathIndex].z + " ) "; 
										AddTask(CTask.TASK_WALKING_PATH, getAID(), sNewPosition, m_TaskPriority[CTask.TASK_WALKING_PATH]);
										lastValidRearIndex = -1;
										operationState = GOING_HOME;
										soldierState = AT_WORK;
										log.writeLine("CHANGE STATE 7");
									}
									else{
										//El soldado est mal situado hay que hacer que cambie de direccin para que se cruce con el portador
										m_AStarPath = hellPath;
										m_iAStarPathIndex = toHellPathIndex - (lastValidRearIndex);
										log.writeLine("Uso toHellPathIndex:"+toHellPathIndex);
										sNewPosition = " ( " + m_AStarPath[m_iAStarPathIndex].x + " , " + 0 + " , " + m_AStarPath[m_iAStarPathIndex].z + " ) "; 
										AddTask(CTask.TASK_WALKING_PATH, getAID(), sNewPosition, m_TaskPriority[CTask.TASK_WALKING_PATH]);
										lastValidRearIndex = -1;
										operationState = GOING_HELL;
										soldierState = AT_WORK;
										log.writeLine("CHANGE STATE 8");
									}
									break;
								}
								break;
							default:
								//Put code here
								break;
							}
							break;
						case GOING_HOME:
							switch (soldierState){
							case AT_WORK:
								switch (currentTask){
								case CTask.TASK_WALKING_PATH:
									//El soldado est volviendo a casa y por lo tanto en buena direccin.
									//Hay que saber si esta detrs o delante del portador para recolocarlo en este caso
									my_toHomePathIndex = m_iAStarPathIndex;
									//Averiguo a que ndice del camino al objetivo corresponde el ndice del camino a casa en el que esta el portador								
									if (toHomePathIndex-my_toHomePathIndex>=0){								
										//El soldado est bien situado, no hay que hacer nada
										log.writeLine("NO CHANGE STATE 9");
									}
									else{
										//El soldado est mal situado hay que hacer que cambie de direccin para que se cruce con el portador
										m_AStarPath = hellPath;
										m_iAStarPathIndex = homePath.length - my_toHomePathIndex - 2;
										if (m_iAStarPathIndex<0){
											m_iAStarPathIndex = 0;
										}
										else{
											m_iAStarPathIndex++;
										}
										sNewPosition = " ( " + m_AStarPath[m_iAStarPathIndex].x + " , " + 0 + " , " + m_AStarPath[m_iAStarPathIndex].z + " ) "; 
										AddTask(CTask.TASK_WALKING_PATH, getAID(), sNewPosition, m_TaskPriority[CTask.TASK_WALKING_PATH]);
										lastValidRearIndex = -1;
										operationState = GOING_HELL;
										soldierState = AT_WORK;
										log.writeLine("CHANGE STATE 9");
									}
									break;
								default:
									//No se cmo lleg donde estoy
									//La manera segura de proceder es pedir una ruta a casa al CAstar
									//sin embargo, podemos suponer (al 90%) que lo que ocurri es que la homePath se finaliz 
									//de modo que el soldado est en algn sitio cerca del punto final de homePath.
									//El soldado volva a casa y por lo tanto en buena direccin.
									//Hay que saber si esta detrs o delante del portador para recolocarlo en este caso
									//Averiguo qu ndice del camino homePath se corresponde en coordenadas con el ndice del camino rearPath al que voy.
									my_toHomePathIndex = homePath.length - 1;
									//Averiguo a que ndice del camino al objetivo corresponde el ndice del camino a casa en el que esta el portador								
									if (toHomePathIndex-my_toHomePathIndex>=0){								
										//El soldado est bien situado, no hay que hacer nada
										log.writeLine("NO CHANGE STATE 10");
									}
									else{
										//El soldado est mal situado hay que hacer que cambie de direccin para que se cruce con el portador
										//Busco la posicin mas cercana a la mia en el hellPath
										Vector3D myPos = new Vector3D(m_Movement.getPosition());
										double d = MAX_DISTANCE;
										int index = -1;
										for (int i=0;i<hellPath.length;i++){
											double cd = distance(myPos,hellPath[i]);
											if (cd<d){
												cd = d;
												index = i;
											}
										}
										if (index>=0 && CheckStaticPosition(hellPath[index].x, hellPath[index].z)){
											m_AStarPath = hellPath;
											m_iAStarPathIndex = index;
											sNewPosition = " ( " + m_AStarPath[m_iAStarPathIndex].x + " , " + 0 + " , " + m_AStarPath[m_iAStarPathIndex].z + " ) "; 
											AddTask(CTask.TASK_WALKING_PATH, getAID(), sNewPosition, m_TaskPriority[CTask.TASK_WALKING_PATH]);
											lastValidRearIndex = -1;
											operationState = GOING_HELL;
											soldierState = AT_WORK;
										}
										log.writeLine("CHANGE STATE 10");
									}
									break;
								}
								break;
							case TAKING_BREAK:
								switch (currentTask){
								case CTask.TASK_WALKING_PATH:
									//No definimos nada volviendo a casa
									//Esta situacin es imposible (al 90%). No hago nada.
									break;
								default:
									//No definimos nada volviendo a casa
									//Esta situacin es imposible (al 90%). No hago nada.
									break;
								}
								break;
							default:
								//Put code here
								break;
							}
							break;
						default:
							//Put code here
							break;
						}	

						return;
					}

					/*
				if (msg.getConversationId().equals(FORE_POS)){
					StringTokenizer tokens = new StringTokenizer(msg.getContent());
					double distance = Double.parseDouble(tokens.nextToken());
					//Un compaero ve enemigos ms cerca que yo, su posicin puede ser el frente
					if (distance<foreDistance){
						foreDistance = distance;
						tokens.nextToken();
						forePos.x = Double.parseDouble(tokens.nextToken());
						tokens.nextToken();
						forePos.y = Double.parseDouble(tokens.nextToken());
						tokens.nextToken();
						forePos.z = Double.parseDouble(tokens.nextToken());
					}
					log.writeLine("fore recibido");
					return;
				}
				if (msg.getConversationId().equals(REAR_POS)){
					StringTokenizer tokens = new StringTokenizer(msg.getContent());
					//Un compaero enva una posible posicin de retaguardia
					Vector3D spRearPos = new Vector3D();
					tokens.nextToken();
					spRearPos.x = Double.parseDouble(tokens.nextToken());
					tokens.nextToken();
					spRearPos.y = Double.parseDouble(tokens.nextToken());
					tokens.nextToken();
					spRearPos.z = Double.parseDouble(tokens.nextToken());	
					double palDistance = distance(spRearPos,forePos);
					double myDistance = distance(m_Movement.getPosition(),forePos);
					if (myDistance<palDistance){
						rearPos = spRearPos;
					}
					log.writeLine("rear recibido");
					return;
				}
					 */
				}
				else{
					if (msg.getConversationId().equals(LOST_FLAG)){
						log.writeLine("DEFENSA: LOST_FLAG received");
						
						return;
					}
					if (msg.getConversationId().equals(GOT_FLAG)){
						log.writeLine("DEFENSA: GOT_FLAG received");
						
						return;
					}
					/*
					if (msg.getConversationId().equals(ENEMY_POS)){
						if (m_CurrentTask.getType()!=CTask.TASK_WALKING_PATH && m_AimedAgent == null){
							log.writeLine("ENEMY_POS received");
							StringTokenizer tokens = new StringTokenizer(msg.getContent());
							tokens.nextToken();
							double x1 = Double.parseDouble(tokens.nextToken());
							tokens.nextToken();
							double y1 = Double.parseDouble(tokens.nextToken());
							tokens.nextToken();
							double z1 = Double.parseDouble(tokens.nextToken());
							hellPath = pathFinder.getPathToInitialFlag(((Vector3D)m_Movement.getPosition()).x,((Vector3D)m_Movement.getPosition()).z,x1,z1);
							m_AStarPath = hellPath;
							m_iAStarPathIndex = 0;
							String sNewPosition = " ( " + m_AStarPath[m_iAStarPathIndex].x + " , " + 0 + " , " + m_AStarPath[m_iAStarPathIndex].z + " ) ";
							AddTask(CTask.TASK_WALKING_PATH, getAID(), sNewPosition,m_CurrentTask.getPriority()+1);
						}
						return;
					}
					*/
				}
				
			}
			else{
				block();
			}

		}
	};

	
	
	

	//Comportamiento encargado de averiguar cuantos compaeros quedan vivos
	public class GetPals extends TickerBehaviour{
		public GetPals(Agent arg0, long arg1) {
			super(arg0, arg1);
		}
		protected void onTick() {		
			try {
				DFAgentDescription dfag = new DFAgentDescription();
				ServiceDescription sd = new ServiceDescription();
				sd.setType("pal"+team);
				dfag.addServices(sd);
				pals = DFService.search(myAgent,dfag);
			} catch (FIPAException e) {
				e.printStackTrace();
			}	
		}
	}

	//Comportamiento encargado de avisar de la posesin de bandera y posicion
	public class SendFlagPos extends TickerBehaviour{
		public SendFlagPos(Agent arg0, long arg1) {
			super(arg0, arg1);
		}
		protected void onTick() {
			DFAgentDescription dfag = new DFAgentDescription();
			if (pals!=null){
				int i = pals.length-1;
				//Si hay alguien ms aparte de mi le envio el ndice de la homePath al que voy
				if (i>1){
					ACLMessage gf_msg = new ACLMessage(ACLMessage.REQUEST);
					do{
						DFAgentDescription pal = pals[i--];
						AID palAID = pal.getName();
						//No me envo la posicin a mi mismo
						if (palAID.equals(getName())) continue;
						gf_msg.addReceiver(palAID);
					}while (i>=0);
					gf_msg.setContent(String.valueOf(m_iAStarPathIndex));
					gf_msg.setConversationId(GOT_FLAG);
					send(gf_msg);
					return;	
				}
			}
			System.out.println(getLocalName()+" Arrrg! estoy solo!");	
		}

	}

	//Comportamiento encargado de calcular la ruta de ida y vuelta al objetivo
	public class calculatePath extends OneShotBehaviour{
		public void action(){
			if (m_eTeam == TEAM_ALLIED) {
				pathFinder = CAstar.getInstance(m_Map);
				Holder<Vector3D[]> m_AStarPathH = new Holder<Vector3D[]>();
				Holder<Vector3D[]> homePathH = new Holder<Vector3D[]>();
				pathFinder.getPathToInitialFlag(((Vector3D)m_Movement.getPosition()).x,((Vector3D)m_Movement.getPosition()).z,m_AStarPathH,homePathH);
				hellPath = m_AStarPathH.value;
				homePath = homePathH.value;
				m_AStarPath = hellPath;
				m_iAStarPathIndex = 0;
				String sNewPosition = " ( " + m_AStarPath[m_iAStarPathIndex].x + " , " + 0 + " , " + m_AStarPath[m_iAStarPathIndex].z + " ) "; 
				AddTask(CTask.TASK_WALKING_PATH, getAID(), sNewPosition, m_TaskPriority[CTask.TASK_WALKING_PATH]);
			}
			else {
				CreateControlPoints();
				pathFinder = new CAstar(m_Map);
				hellPath = pathFinder.getPathToInitialFlag(((Vector3D)m_Movement.getPosition()).x,((Vector3D)m_Movement.getPosition()).z,m_ControlPoints[1].x,m_ControlPoints[1].z);
				m_AStarPath = hellPath;
				m_iAStarPathIndex = 0;
				String sNewPosition = " ( " + m_AStarPath[m_iAStarPathIndex].x + " , " + 0 + " , " + m_AStarPath[m_iAStarPathIndex].z + " ) "; 
				//AddTask(CTask.TASK_WALKING_PATH, getAID(), sNewPosition, m_TaskPriority[CTask.TASK_WALKING_PATH]);
				AddTask(CTask.TASK_WALKING_PATH, getAID(), sNewPosition);
			}
		}
	}

	
	/////////////////////////////////////////////////////////////////////////////////////////////////////
	/**
	 * The agent has got the objective pack. 
	 * 
	 * This method is called when this agent walks on the objective pack, getting it.
	 *   
	 * <em> It's very useful to overload this method. </em>
	 *   
	 */
	/////////////////////////////////////////////////////////////////////////////////////////////////////
	protected void ObjectivePackTaken() {
		if (m_eTeam == TEAM_ALLIED) {
			//Me he topado con la bandera, analizo mi situacin y me encargo de ella
			log.writeLine("OBJETIVO TOMADO!!!");
			gotFlag = true;
			int toHomePathIndex;
			String sNewPosition;
			int currentTask = m_CurrentTask.getType();
			switch (operationState){
			case GOING_HELL:
				switch (soldierState){
				case AT_WORK:
					switch (currentTask){
					case CTask.TASK_WALKING_PATH:
						//Estaba siguiendo hellPath
						//Conversion de indices entre rutas de ida y vuelta de posicion identica
						toHomePathIndex = hellPath.length - m_iAStarPathIndex - 2;
						if (toHomePathIndex<0){
							toHomePathIndex = 0;
						}
						else{
							toHomePathIndex++;
						}
						m_AStarPath = homePath;
						m_iAStarPathIndex = toHomePathIndex;
						sNewPosition = " ( " + m_AStarPath[m_iAStarPathIndex].x + " , " + 0 + " , " + m_AStarPath[m_iAStarPathIndex].z + " ) "; 
						AddTask(CTask.TASK_WALKING_PATH, getAID(), sNewPosition, m_TaskPriority[CTask.TASK_WALKING_PATH]);

						operationState = GOING_HOME;
						soldierState = AT_WORK;
						log.writeLine("CHANGE STATE 11");
						addBehaviour(new SendFlagPos(this,GOT_FLAG_LAP));
						break;
					default:
						//No se cmo lleg donde estoy
						//La manera segura de proceder es pedir una ruta a casa al CAstar
						//sin embargo, podemos suponer (al 90%) que lo que ocurri es que la hellPath se finaliz 
						//de modo que el soldado est en algn sitio cerca del punto final de hellPath. 
						toHomePathIndex = 0;
						m_AStarPath = homePath;
						m_iAStarPathIndex = toHomePathIndex;
						sNewPosition = " ( " + m_AStarPath[m_iAStarPathIndex].x + " , " + 0 + " , " + m_AStarPath[m_iAStarPathIndex].z + " ) "; 
						AddTask(CTask.TASK_WALKING_PATH, getAID(), sNewPosition, m_TaskPriority[CTask.TASK_WALKING_PATH]);

						operationState = GOING_HOME;
						soldierState = AT_WORK;
						addBehaviour(new SendFlagPos(this,GOT_FLAG_LAP));
						log.writeLine("CHANGE STATE 12");
						break;
					}
					break;
				case TAKING_BREAK:
					switch (currentTask){
					case CTask.TASK_WALKING_PATH:
						//Estaba siguiendo rearPath, que es una sub ruta de homePath, que es la inversa de hellPath					
						//Averiguo qu ndice del camino homePath se corresponde en coordenadas con el ndice del camino rearPath al que voy.
						toHomePathIndex = hellPath.length - (toHellPathIndex - m_iAStarPathIndex - 1) - 2;
						log.writeLine("Uso toHellPathIndex:"+toHellPathIndex);
						if (toHomePathIndex<0){
							toHomePathIndex = 0;
						}
						m_AStarPath = homePath;
						m_iAStarPathIndex = toHomePathIndex;
						sNewPosition = " ( " + m_AStarPath[m_iAStarPathIndex].x + " , " + 0 + " , " + m_AStarPath[m_iAStarPathIndex].z + " ) "; 
						AddTask(CTask.TASK_WALKING_PATH, getAID(), sNewPosition, m_TaskPriority[CTask.TASK_WALKING_PATH]);
						lastValidRearIndex = -1;
						operationState = GOING_HOME;
						soldierState = AT_WORK;
						addBehaviour(new SendFlagPos(this,GOT_FLAG_LAP));
						log.writeLine("CHANGE STATE 13");
						break;
					default:
						//No se cmo lleg donde estoy
						//La manera segura de proceder es pedir una ruta a casa al CAstar
						//sin embargo, podemos suponer (al 90%) que lo que ocurri es que la rearPath se finaliz 
						//de modo que el soldado est en algn sitio cerca del punto final de rearPath.
						//Averiguo qu ndice del camino homePath se corresponde en coordenadas con el ndice del camino rearPath en el que estoy.
						toHomePathIndex = hellPath.length - (toHellPathIndex - (lastValidRearIndex) - 1) - 2;
						log.writeLine("Uso toHellPathIndex:"+toHellPathIndex);
						if (toHomePathIndex<0){
							toHomePathIndex = 0;
						}
						m_AStarPath = homePath;
						m_iAStarPathIndex = toHomePathIndex;
						sNewPosition = " ( " + m_AStarPath[m_iAStarPathIndex].x + " , " + 0 + " , " + m_AStarPath[m_iAStarPathIndex].z + " ) "; 
						AddTask(CTask.TASK_WALKING_PATH, getAID(), sNewPosition, m_TaskPriority[CTask.TASK_WALKING_PATH]);
						lastValidRearIndex = -1;
						operationState = GOING_HOME;
						soldierState = AT_WORK;
						addBehaviour(new SendFlagPos(this,GOT_FLAG_LAP));
						log.writeLine("CHANGE STATE 14");
						break;
					}
					break;
				default:
					//Put code here
					break;
				}
				break;
			case GOING_HOME:
				switch (soldierState){
				case AT_WORK:
					switch (currentTask){
					case CTask.TASK_WALKING_PATH:
						//Voy a casa, estoy de servicio y no he llegado todava.
						//No hago nada excepto informar
						operationState = GOING_HOME;
						soldierState = AT_WORK;
						addBehaviour(new SendFlagPos(this,GOT_FLAG_LAP));
						log.writeLine("CHANGE STATE 15");
						break;
					default:
						//Voy a casa, estoy de servicio y ya he llegado.
						//Esta situacin es imposible (al 90%). No hago nada.
						operationState = GOING_HOME;
						soldierState = AT_WORK;
						log.writeLine("CHANGE STATE 16");
						break;
					}
					break;
				case TAKING_BREAK:
					switch (currentTask){
					case CTask.TASK_WALKING_PATH:
						//No se puede (de momento) estar volviendo a casa y de permiso a la vez.
						//Esta situacin es imposible (al 90%). No hago nada.
						break;
					default:
						//No se puede (de momento) estar volviendo a casa y de permiso a la vez.
						//Esta situacin es imposible (al 90%). No hago nada.
						break;
					}
					break;
				default:
					//Put code here
					break;
				}
				break;
			default:
				//Put code here
				break;
			}
		}
		else {
			//He recuperado la bandera defendiendo
		}
	}





	/////////////////////////////////////////////////////////////////////////////////////////////////////
	/**
	 * Action to do when the agent is looking at. 
	 * 
	 * This method is called just after Look method has ended. 
	 *   
	 * <em> It's very useful to overload this method. </em>
	 * 
	 */
	protected void PerformLookAction() {
		if (m_eTeam == TEAM_ALLIED) {
			medicAtView = false;
			fieldOpAtView = false;
			if ( m_FOVObjects.isEmpty()){
				return;
			}
			Iterator it = m_FOVObjects.iterator();
			while ( it.hasNext() ) {                                                
				CSight s = (CSight) it.next();
				if ( s.getType() >= CPack.PACK_NONE ) {
					continue;
				}
				int eTeam = s.getTeam();
				if ( m_eTeam == eTeam ){
					if (soldierState == AT_WORK && operationState == GOING_HELL && System.currentTimeMillis()<SHAPE_TIME){

					}
					else{
						if (soldierState == TAKING_BREAK && s.getDistance()<30){
							if (s.getType()==2){
								medicAtView = true;
							}
							if (s.getType()==4){
								fieldOpAtView = true;
							}
						}
					}
					continue;
				}
			}
		}
		else {
			if ( m_FOVObjects.isEmpty()){
				return;
			}
			boolean flagSeen = false;
			Iterator it = m_FOVObjects.iterator();
			while ( it.hasNext() ) {                                                
				CSight s = (CSight) it.next();
				if (!flagSeen && s.getType() == CPack.PACK_OBJPACK){
					flagSeen = true;
				}
				if ( s.getType() == CPack.PACK_OBJPACK && distance(s.getPosition(),new Vector3D(m_Map.GetTargetX(),0,m_Map.GetTargetZ()))!=0) {
					String sNewPosition = " ( " + s.getPosition().x + " , " + 0 + " , " + s.getPosition().z + " ) "; 
					AddTask(CTask.TASK_GOTO_POSITION, getAID(), sNewPosition, m_CurrentTask.getPriority() + 1);
					return;
				}
			}
		}
	}
	/////////////////////////////////////////////////////////////////////////////////////////////////////
		
	
/////////////////////////////////////////////////////////////////////////////////////////////////////
	/**
	 * Calculates if there is an enemy at sight. 
	 * 
	 * This method scans the list <tt> m_FOVObjects</tt> (objects in the Field Of View of the agent) looking for an enemy.
	 * If an enemy agent is found, a value of <tt> TRUE</tt> is returned and variable <tt> m_AimedAgent</tt> is updated.
	 * Note that there is no criterion (proximity, etc.) for the enemy found.
	 * Otherwise, the return value is <tt> FALSE</tt>.
	 *   
	 * <em> It's very useful to overload this method. </em>
	 *   
	 * @return <tt> TRUE</tt>: enemy found / <tt> FALSE</tt> enemy not found
	 * 
	 */
	protected boolean GetAgentToAim() {	
		if (m_eTeam == TEAM_ALLIED) {
			boolean palAtView = false;
			m_AimedAgent = null;
			double distance = MAX_DISTANCE;
			if ( m_FOVObjects.isEmpty()){
				return false;
			}
			Iterator it = m_FOVObjects.iterator();
			while ( it.hasNext() ) {                                                
				CSight s = (CSight) it.next();
				if ( s.getType() >= CPack.PACK_NONE ) {
					continue;
				}
				int eTeam = s.getTeam();

				if ( m_eTeam == eTeam ){
					palAtView = true;
					break;
				}
				if (distance > s.getDistance()){
					m_AimedAgent = s;
					distance = s.getDistance();
				}
			}
			//Si hay compaeros a la vista no disparar
			if (palAtView){
				m_AimedAgent = null;
			}
			if (m_AimedAgent == null){
				return false;
			}
			return true;
		}
		else {
			int palCounter = 0;
			int eneCounter = 0;
			double ene_distance = MAX_DISTANCE;
			double pal_distance = MAX_DISTANCE;
			double x_cent = 0;
			double z_cent = 0;
			if ( m_FOVObjects.isEmpty()){
				return false;
			}
			CSight a = null;
			Iterator it = m_FOVObjects.iterator();
			while ( it.hasNext() ) {                                                
				CSight s = (CSight) it.next();
				if ( s.getType() >= CPack.PACK_NONE ) {
					continue;
				}

				if ( m_eTeam == s.getTeam()){
					palCounter++;
					if (pal_distance > s.getDistance()){
						pal_distance = s.getDistance();
					}
					continue;
				}
				eneCounter++;
				x_cent = x_cent + s.getPosition().x;
				z_cent = z_cent + s.getPosition().z;
				if (ene_distance > s.getDistance()){
					a = s;
					ene_distance = s.getDistance();
				}
			}

			if (a==null){
				m_AimedAgent = null;
				return false;
			}
			else {
				String sNewPosition = " ( " + a.getPosition().x + " , " + 0 + " , " + a.getPosition().z + " ) "; 
				AddTask(CTask.TASK_GOTO_POSITION, getAID(), sNewPosition, m_CurrentTask.getPriority() + 1);
				m_AimedAgent = a;
				return true;
				/*
				DFAgentDescription dfag = new DFAgentDescription();
				if (pals!=null){
					int i = pals.length-1;
					if (i>1){
						ACLMessage gf_msg = new ACLMessage(ACLMessage.REQUEST);
						do{
							DFAgentDescription pal = pals[i--];
							AID palAID = pal.getName();
							//No me lo envo a mi mismo
							if (palAID.equals(getName())) continue;
							gf_msg.addReceiver(palAID);
						}while (i>=0);
						gf_msg.setContent(" ( " + a.getPosition().x + " , " + 0 + " , " + a.getPosition().z + " ) ");
						gf_msg.setConversationId(ENEMY_POS);
						send(gf_msg);
					}
				}

				if (ene_distance<pal_distance){
					String sNewPosition = " ( " + a.getPosition().x + " , " + 0 + " , " + a.getPosition().z + " ) "; 
					AddTask(CTask.TASK_GOTO_POSITION, getAID(), sNewPosition, m_CurrentTask.getPriority() + 1);
					m_AimedAgent = a;
					return true;
				}
				else{
					m_AimedAgent = null;
					return false;
				}
				 */
			}
		}
	}
	/////////////////////////////////////////////////////////////////////////////////////////////////////
	private double distance(Vector3D p1, Vector3D p2){
		return Math.sqrt(Math.pow((p1.x-p2.x),2)+Math.pow((p1.y-p2.y),2)+Math.pow((p1.z-p2.z),2));
	}
	
	
	
	protected void MedicsMustWait() {
		try {
			DFAgentDescription dfd = new DFAgentDescription();
			ServiceDescription sd = new ServiceDescription();
			sd.setType(m_sMedicService);
			dfd.addServices(sd);
			DFAgentDescription[] result = DFService.search(this, dfd);
			if ( result.length > 0 ) {
				ACLMessage msg = new ACLMessage(ACLMessage.REQUEST);
				for ( int i = 0; i < result.length; i++ ) {
					DFAgentDescription dfdMedic = result[i];
					msg.addReceiver(dfdMedic.getName());
				}
				msg.setConversationId(WAIT);
				msg.setContent(" ( " + 	m_Movement.getPosition().x + " , " + 
										m_Movement.getPosition().y + " , " + 
										m_Movement.getPosition().z + " ) ");
				send(msg);			
			}
		} catch (FIPAException fe) {
			fe.printStackTrace();
		}
	}
	protected void FieldOpsMustWait() {
		try {
			DFAgentDescription dfd = new DFAgentDescription();
			ServiceDescription sd = new ServiceDescription();
			sd.setType(m_sAmmoService);
			dfd.addServices(sd);
			DFAgentDescription[] result = DFService.search(this, dfd);
			if ( result.length > 0 ) {
				ACLMessage msg = new ACLMessage(ACLMessage.REQUEST);
				for ( int i = 0; i < result.length; i++ ) {
					DFAgentDescription dfdFieldOp = result[i];
					msg.addReceiver(dfdFieldOp.getName());
				}
				msg.setConversationId(WAIT);
				msg.setContent(" ( " + 	m_Movement.getPosition().x + " , " + 
										m_Movement.getPosition().y + " , " + 
										m_Movement.getPosition().z + " ) ");
				send(msg);			
			}
		} catch (FIPAException fe) {
			fe.printStackTrace();
		}
	}
	
	/////////////////////////////////////////////////////////////////////////////////////////////////////
	/**
	 * Definition of priorities for each kind of task. 
	 * 
	 * This method can be implemented in CTroop's derived classes to define the task's priorities in agreement to
	 * the role of the new class. Priorities must be defined in the array <tt> m_TaskPriority</tt>. 
	 *   
	 * <em> It's very useful to overload this method. </em>
	 *   
	 */
	protected void SetUpPriorities() {
		if (m_eTeam == TEAM_ALLIED) {
			m_TaskPriority[CTask.TASK_NONE] = 0;
			m_TaskPriority[CTask.TASK_GIVE_MEDICPAKS] = 1500;
			m_TaskPriority[CTask.TASK_GIVE_AMMOPACKS] = 0;
			m_TaskPriority[CTask.TASK_GIVE_BACKUP] = 0;
			//NOTA: si m_TaskPriority[CTask.TASK_GET_OBJECTIVE] = 0 casca en arranque!. Arranca con esta tarea a pion fijo.
			m_TaskPriority[CTask.TASK_GET_OBJECTIVE] = 500;
			m_TaskPriority[CTask.TASK_ATTACK] = 0;
			m_TaskPriority[CTask.TASK_RUN_AWAY] = 0;
			m_TaskPriority[CTask.TASK_GOTO_POSITION] = 0;
			m_TaskPriority[CTask.TASK_PATROLLING] = 0;
			m_TaskPriority[CTask.TASK_WALKING_PATH] = 1000;
		}
		else{
			m_TaskPriority[CTask.TASK_NONE] = 0;
			m_TaskPriority[CTask.TASK_GIVE_MEDICPAKS] = 4000;
			m_TaskPriority[CTask.TASK_GIVE_AMMOPACKS] = 0;
			m_TaskPriority[CTask.TASK_GIVE_BACKUP] = 0;
			//NOTA: si m_TaskPriority[CTask.TASK_GET_OBJECTIVE] = 0 casca en arranque!. Arranca con esta tarea a pion fijo.
			m_TaskPriority[CTask.TASK_GET_OBJECTIVE] = 0;
			m_TaskPriority[CTask.TASK_ATTACK] = 0;
			m_TaskPriority[CTask.TASK_RUN_AWAY] = 0;
			m_TaskPriority[CTask.TASK_GOTO_POSITION] = 0;
			m_TaskPriority[CTask.TASK_PATROLLING] = 2000;
			m_TaskPriority[CTask.TASK_WALKING_PATH] = 3000;	
		}
	}
	/////////////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////////////
	/**
	 * Update priority of all 'prepared (to execute)' tasks. 
	 * 
	 * This method is invoked in the state <em>STANDING</em>, and it's used to re-calculate the priority of all tasks (targets) int the task list
	 * of the agent. The reason is because JGOMAS Kernel always execute the maximum priority task. 
	 * 
	 * <em> It's very useful to overload this method. </em>
	 *    
	 */
	protected void UpdateTargets() {} 
	/////////////////////////////////////////////////////////////////////////////////////////////////////

	/////////////////////////////////////////////////////////////////////////////////////////////////////
	/**
	 * Should we update now all 'prepared (to execute)' tasks? 
	 * 
	 * This method is a decision function invoked in the state <em>GOTO_TARGET</em>. A value of <tt> TRUE</tt> break out the inner loop, 
	 * making possible to JGOMAS Kernel extract a more priority task, or update some attributes of the current task.
	 * By default, the return value is <tt> FALSE</tt>, so we execute the current task until it finalizes.
	 *   
	 * <em> It's very useful to overload this method. </em>
	 *   
	 * @return <tt> FALSE</tt> 
	 * 
	 */
	protected boolean ShouldUpdateTargets() {
		//NOTA: Si true permite dejar lo que se estaba haciendo para recalcular prioridades.
		//Se ha de devolver true al menos la primera vez para que haga caso del SetUpPriorities.
		return true; 
	}  
	/////////////////////////////////////////////////////////////////////////////////////////////////////









	/////////////////////////////////////////////////////////////////////////////////////////////////////
	// Methods to overload inhereted from CTroop class
	//

	/////////////////////////////////////////////////////////////////////////////////////////////////////

	/**
	 * Request for medicine. 
	 * 
	 * This method sends a <b> FIPA REQUEST </b> message to all agents who offers the <tt> m_sMedicService </tt> service.
	 * 
	 * The content of message is: <tt> ( x , y , z ) ( health ) </tt>.
	 * 
	 * Variable <tt> m_iMedicsCount </tt> is updated.
	 * 
	 * <em> It's very useful to overload this method. </em>
	 * 
	 */

	protected void CallForMedic() {
		if (m_eTeam == TEAM_ALLIED){
			needMedicPacks = true;
		}
		else {
			super.CallForMedic();
		}
	}
	/////////////////////////////////////////////////////////////////////////////////////////////////////

	
	public class DeferredCallForMedic extends TickerBehaviour{
		public DeferredCallForMedic(Agent arg0, long arg1) {
			super(arg0, arg1);
		}
		protected void onTick() {		
			if (needMedicPacks && medicAtView && soldierState==TAKING_BREAK){
				try {
					DFAgentDescription dfd = new DFAgentDescription();
					ServiceDescription sd = new ServiceDescription();
					sd.setType(m_sMedicService);
					dfd.addServices(sd);
					DFAgentDescription[] result = DFService.search(this.myAgent, dfd);
					if ( result.length > 0 ) {
						m_iMedicsCount = result.length;
						// Fill the REQUEST message
						ACLMessage msg = new ACLMessage(ACLMessage.REQUEST);
						for ( int i = 0; i < result.length; i++ ) {
							DFAgentDescription dfdMedic = result[i];
							AID Medic = dfdMedic.getName();
							if ( ! Medic.equals(getName()) )
								msg.addReceiver(dfdMedic.getName());
							else
								m_iMedicsCount--;
						}
						msg.setProtocol(FIPANames.InteractionProtocol.FIPA_REQUEST);
						msg.setConversationId("CFM");					
						//msg.setContent(" ( " + m_Movement.getPosition().x + " , " + m_Movement.getPosition().y + " , " + m_Movement.getPosition().z + " ) ( " + GetHealth() + " ) ");
						int lastRearPathIndex = lastValidRearIndex;
						msg.setContent(" ( " + rearPath[lastRearPathIndex].x + " , " + rearPath[lastRearPathIndex].y + " , " + rearPath[lastRearPathIndex].z + " ) ( " + GetHealth() + " ) ");
						send(msg);
						System.out.println(getLocalName()+ ": Need a Medic! (v21)");
					} else {
						m_iMedicsCount = 0;
					}
				} catch (FIPAException fe) {
					fe.printStackTrace();
				}
				needMedicPacks = false;
				removeBehaviour(this);
			}
		}
	}
	/////////////////////////////////////////////////////////////////////////////////////////////////////
	/**
	 * Request for ammunition. 
	 * 
	 * This method sends a <b> FIPA REQUEST </b> message to all agents who offers the <tt> m_sAmmoService </tt> service.
	 * 
	 * The content of message is: <tt> ( x , y , z ) ( ammo ) </tt>.
	 * 
	 * Variable <tt> m_iFieldOpsCount </tt> is updated.
	 * 
	 * <em> It's very useful to overload this method. </em>
	 *    
	 */
	protected void CallForAmmo() {
		if (m_eTeam == TEAM_ALLIED) {
			needAmmoPacks = true;
		}
		else {
			super.CallForAmmo();
		}
	}
	/////////////////////////////////////////////////////////////////////////////////////////////////////

	
	public class DeferredCallForAmmo extends TickerBehaviour{
		public DeferredCallForAmmo(Agent arg0, long arg1) {
			super(arg0, arg1);
		}
		protected void onTick() {
			if (needAmmoPacks && fieldOpAtView && soldierState==TAKING_BREAK){
				try {
					DFAgentDescription dfd = new DFAgentDescription();
					ServiceDescription sd = new ServiceDescription();
					sd.setType(m_sAmmoService);
					dfd.addServices(sd);
					DFAgentDescription[] result = DFService.search(this.myAgent, dfd);
					if ( result.length > 0 ) {
						m_iFieldOpsCount = result.length;
						// Fill the REQUEST message
						ACLMessage msg = new ACLMessage(ACLMessage.REQUEST);
						for ( int i = 0; i < result.length; i++ ) {
							DFAgentDescription dfdFieldOps = result[i];
							AID Medic = dfdFieldOps.getName();
							if ( ! Medic.equals(getName()) )
								msg.addReceiver(dfdFieldOps.getName());
							else
								m_iFieldOpsCount--;
						}
						msg.setProtocol(FIPANames.InteractionProtocol.FIPA_REQUEST);
						msg.setConversationId("CFA");					
						//msg.setContent(" ( " + m_Movement.getPosition().x + " , " + m_Movement.getPosition().y + " , " + m_Movement.getPosition().z + " ) ( " + GetHealth() + " ) ");
						int lastRearPathIndex = lastValidRearIndex;
						msg.setContent(" ( " + rearPath[lastRearPathIndex].x + " , " + rearPath[lastRearPathIndex].y + " , " + rearPath[lastRearPathIndex].z + " ) ( " + GetAmmo() + " ) ");
						send(msg);
						System.out.println(getLocalName()+ ": Need Ammo! (v21)");
					} else {
						m_iFieldOpsCount = 0;
					}
				} catch (FIPAException fe) {
					fe.printStackTrace();
				}
				needAmmoPacks = false;
				removeBehaviour(this);
			}
		}
	}

	/////////////////////////////////////////////////////////////////////////////////////////////////////
	/**
	 * Request for backup. 
	 * 
	 * This method sends a <b> FIPA REQUEST </b> message to all agents who offers the <tt> m_sBackupService</tt> service.
	 * 
	 * The content of message is: <tt> ( x , y , z ) ( SoldiersCount ) </tt>.
	 * 
	 * Variable <tt> m_iSoldiersCount </tt> is updated.
	 * 
	 * <em> It's very useful to overload this method. </em>
	 *    
	 */
	protected void CallForBackup() {


		super.CallForBackup();

	}
	/////////////////////////////////////////////////////////////////////////////////////////////////////



	
	




	/////////////////////////////////////////////////////////////////////////////////////////////////////
	/**
	 * Action to do if this agent cannot shoot. 
	 * 
	 * This method is called when the agent try to shoot, but has no ammo. The agent will spit enemies out. :-) 
	 *   
	 * <em> It's very useful to overload this method. </em>
	 *   
	 */
	protected void PerformNoAmmoAction() {}
	/////////////////////////////////////////////////////////////////////////////////////////////////////

	/////////////////////////////////////////////////////////////////////////////////////////////////////
	/**
	 * Calculates a new destiny position to escape. 
	 * 
	 * This method is called before the agent creates a task for escaping. It generates a valid random point in a radius of 50 units.
	 * Once position is calculated, agent updates its destiny to the new position, and automatically calculates the new direction.
	 *   
	 * <em> It's very useful to overload this method. </em>
	 *   
	 */
	protected void GenerateEscapePosition() {
		/*log.writeLine("GenerateEscapePosition");
		String sNewPosition = " ( " + 	m_Movement.getDestination().x + " , " + 
										m_Movement.getDestination().y + " , " + 
										m_Movement.getDestination().z + " ) ";
		AddTask(CTask.TASK_NONE, getAID(), sNewPosition, m_CurrentTask.getPriority() + 1);
		return;
		*/
		/*while (true) {
			m_Movement.CalculateNewDestination(50, 50);
			if ( CheckStaticPosition(m_Movement.getDestination().x, m_Movement.getDestination().z) == true ) {
				m_Movement.CalculateNewOrientation();
				return;
			}
		}*/
		
	}
	/////////////////////////////////////////////////////////////////////////////////////////////////////
	
	/////////////////////////////////////////////////////////////////////////////////////////////////////
	/**
	 * Calculates a new destiny position to walk. 
	 * 
	 * This method is called before the agent creates a <tt> TASK_GOTO_POSITION</tt> task. It will try (for 5 attempts) to generate a
	 * valid random point in a radius of 20 units. If it doesn't generate a valid position in this cycle, it will try it in next cycle. 
	 * Once a position is calculated, agent updates its destination to the new position, and automatically calculates the new direction.
	 *   
	 * <em> It's very useful to overload this method. </em>
	 *   
	 * @return <tt> TRUE</tt>: valid position generated / <tt> FALSE</tt> cannot generate a valid position
	 * 
	 */
	protected boolean GeneratePath() {
		if (m_eTeam == TEAM_ALLIED){
			log.writeLine("GeneratePath");
			log.writeLine("toHellPathIndex:"+toHellPathIndex);
			log.writeLine("lastValidRearIndex:"+lastValidRearIndex);
			for (int iAttempts = 0; iAttempts < 10; iAttempts++) {
				m_Movement.CalculateNewDestination(1,1);
				if ( CheckStaticPosition(m_Movement.getDestination().x, m_Movement.getDestination().z) == true ) {
					// we must insert a task to go to a new position, so agent will follow previous path
					String sNewPosition = " ( " + m_Movement.getDestination().x + " , " + m_Movement.getDestination().y + " , " + m_Movement.getDestination().z + " ) "; 
					AddTask(CTask.TASK_GOTO_POSITION, getAID(), sNewPosition, m_CurrentTask.getPriority() + 1);
					return true;
				}
			}
			return false;
		}
		else{
			for (int iAttempts = 0; iAttempts < 10; iAttempts++) {
				m_Movement.CalculateNewDestination(5,5);
				if ( CheckStaticPosition(m_Movement.getDestination().x, m_Movement.getDestination().z) == true ) {
					// we must insert a task to go to a new position, so agent will follow previous path
					String sNewPosition = " ( " + m_Movement.getDestination().x + " , " + m_Movement.getDestination().y + " , " + m_Movement.getDestination().z + " ) "; 
					AddTask(CTask.TASK_GOTO_POSITION, getAID(), sNewPosition, m_CurrentTask.getPriority() + 1);
					return true;
				}
			}
			return false;
		}
	}
	/////////////////////////////////////////////////////////////////////////////////////////////////////

	/////////////////////////////////////////////////////////////////////////////////////////////////////
	/**
	 * Calculates an array of positions for patrolling. 
	 * 
	 * When this method is called, it creates an array of <tt> n</tt> random positions. For medics and fieldops, the rank of <tt> n</tt> is 
	 * [1..1]. For soldiers, the rank of <tt> n</tt> is [5..10].
	 *   
	 * <em> It's very useful to overload this method. </em>
	 *   
	 */
	protected void CreateControlPoints() {

		int iMaxCP = 0;
		
		switch ( m_eClass ) {
		case CLASS_MEDIC:
			if (m_eTeam == TEAM_ALLIED) {
				
			}
			else {
				if (m_ControlPoints==null){
					int nSoldiers = 0;
					DFAgentDescription dfd = new DFAgentDescription();
					ServiceDescription sd = new ServiceDescription();
					sd.setType(m_sBackupService);
					dfd.addServices(sd);
					try {
						nSoldiers = DFService.search(this, dfd).length;
					} catch (FIPAException e) {
						e.printStackTrace();
					}
					double arcLap = 360/nSoldiers;
					double myNumber = Double.parseDouble(getLocalName().substring(1));
					m_ControlPoints = new Vector3D[2];
					double xDisp = m_Map.GetTargetX();
					double zDisp = m_Map.GetTargetZ();
					m_ControlPoints[1] = new Vector3D(0,0,0);
					m_ControlPoints[0] = new Vector3D(0,0,0);
					Vector3D s = new Vector3D(xDisp,0,zDisp);
					double ir = INNER_RADIUS;
					Vector3D t = new Vector3D(OUTER_RADIUS*Math.cos(arcLap*(myNumber-1))+xDisp,0,OUTER_RADIUS*Math.sin(arcLap*(myNumber-1))+zDisp);
					Vector3D i = new Vector3D(0,0,0);
					do{
						double p;
						double d;
						for (p=0;p<=1;p=p+.05d){
							i.x = s.x+(t.x-s.x)*p;
							i.z = s.z+(t.z-s.z)*p;
							d = distance(s,i);
							if (CheckStaticPosition(i.x,i.z)){
								if (d<=ir){
									m_ControlPoints[0].x=i.x;
									m_ControlPoints[0].z=i.z;
									m_ControlPoints[1].x=i.x;
									m_ControlPoints[1].z=i.z;
								}
								else{
									m_ControlPoints[1].x=i.x;
									m_ControlPoints[1].z=i.z;
								}
							}
							else{
								break;
							}	
						}
						ir = ir*.9d;
					}
					//while (distance(m_ControlPoints[1],s)>=5 && distance(m_ControlPoints[0],m_ControlPoints[1])==0);
					while (distance(m_ControlPoints[0],m_ControlPoints[1])<2);
				}
			}
		case CLASS_FIELDOPS:					
		case CLASS_SOLDIER:			
		case CLASS_ENGINEER:
		case CLASS_NONE:
		default:
			break;
		}
	}
	/////////////////////////////////////////////////////////////////////////////////////////////////////

	/////////////////////////////////////////////////////////////////////////////////////////////////////
	/**
	 * Action to do when an agent is being shot. 
	 * 
	 * This method is called every time this agent receives a messager from agent Manager informing it is being shot.
	 *   
	 * <em> It's very useful to overload this method. </em>
	 *   
	 */
	protected void PerformInjuryAction() {
		if (m_eTeam == TEAM_ALLIED) {
			hits++;
			//log.writeLine("hits :"+hits);
			if (hits%HIT_LOOP==0){
				//Ya me han dado suficiente, me voy a dar un respiro
				int toHomePathIndex;
				String sNewPosition;
				int currentTask = m_CurrentTask.getType();
				switch (operationState){
				case GOING_HELL:
					switch (soldierState){
					case AT_WORK:
						switch (currentTask){
						case CTask.TASK_WALKING_PATH:
							//Estaba siguiendo hellPath
							//Miro si tengo ruta de permiso
							if (lastValidRearIndex>=0){
								//m_iAStarPathIndex actual es al punto al que iba, pero no he llegado todava
								toHellPathIndex = m_iAStarPathIndex;
								log.writeLine("Seteo toHellPathIndex:"+toHellPathIndex);
								log.writeLine("lastValidRearIndex:"+lastValidRearIndex);
								log.writeLine("rearPath[0]:                   "+rearPath[0].x+" , "+rearPath[0].z);
								log.writeLine("m_AStarPath[toHellPathIndex-1]:"+m_AStarPath[toHellPathIndex-1].x+" , "+m_AStarPath[toHellPathIndex-1].z);
								log.writeLine("toHellPathIndex:"+toHellPathIndex+" m_iAStarPathIndex:"+m_iAStarPathIndex);
								m_AStarPath = rearPath;
								m_iAStarPathIndex = 0;
								sNewPosition = " ( " + m_AStarPath[m_iAStarPathIndex].x + " , " + 0 + " , " + m_AStarPath[m_iAStarPathIndex].z + " ) "; 
								AddTask(CTask.TASK_WALKING_PATH, getAID(), sNewPosition, m_TaskPriority[CTask.TASK_WALKING_PATH]);
								operationState = GOING_HELL;
								soldierState = TAKING_BREAK;
								addBehaviour(new DeferredCallForMedic(this, 500l));
								addBehaviour(new DeferredCallForAmmo(this, 500l));
							}
							else {
								//No me merezco un descanso, no avanc lo suficiente estando de servicio
							}
							log.writeLine("CHANGE STATE 17");
							break;
						default:
							//No se cmo lleg donde estoy,
							//sin embargo, podemos suponer (al 90%) que lo que ocurri es que la hellPath se finaliz 
							//de modo que el soldado est en algn sitio cerca del punto final de hellPath. 
							//Miro si tengo ruta de permiso
							if (lastValidRearIndex>=0){
								toHellPathIndex = m_AStarPath.length-1;
								log.writeLine("Seteo toHellPathIndex:"+toHellPathIndex);
								m_AStarPath = rearPath;
								m_iAStarPathIndex = 0;
								sNewPosition = " ( " + m_AStarPath[m_iAStarPathIndex].x + " , " + 0 + " , " + m_AStarPath[m_iAStarPathIndex].z + " ) "; 
								AddTask(CTask.TASK_WALKING_PATH, getAID(), sNewPosition, m_TaskPriority[CTask.TASK_WALKING_PATH]);
								operationState = GOING_HELL;
								soldierState = TAKING_BREAK;
								addBehaviour(new DeferredCallForMedic(this, 500l));
								addBehaviour(new DeferredCallForAmmo(this, 500l));
							}
							else {
								//No me merezco un descanso, no avanc lo suficiente estando de servicio
							}
							log.writeLine("CHANGE STATE 18");
							break;
						}
						break;
					case TAKING_BREAK:
						switch (currentTask){
						case CTask.TASK_WALKING_PATH:
							//Estoy de permiso y me siguen dando. Me aguanto
							break;
						default:
							//Estoy a punto de acabar el permiso y me siguen dando. Me aguanto
							break;
						}
						break;
					default:
						//Put code here
						break;
					}
					break;
				case GOING_HOME:
					switch (soldierState){
					case AT_WORK:
						switch (currentTask){
						case CTask.TASK_WALKING_PATH:
							//No definimos nada volviendo a casa
							break;
						default:
							//No definimos nada volviendo a casa
							break;
						}
						break;
					case TAKING_BREAK:
						switch (currentTask){
						case CTask.TASK_WALKING_PATH:
							//No definimos nada volviendo a casa
							//Esta situacin es imposible (al 90%). No hago nada.
							break;
						default:
							//No definimos nada volviendo a casa
							//Esta situacin es imposible (al 90%). No hago nada.
							break;
						}
						break;
					default:
						//Put code here
						break;
					}
					break;
				default:
					//Put code here
					break;
				}	
			}
			return;
		}
		else {
			if (m_AimedAgent==null || (m_AimedAgent==null && GetHealth()<20)){
				for (int iAttempts = 0; iAttempts < 10; iAttempts++) {
					m_Movement.CalculateNewDestination(10,10);
					if ( CheckStaticPosition(m_Movement.getDestination().x, m_Movement.getDestination().z) == true ) {
						// we must insert a task to go to a new position, so agent will follow previous path
						String sNewPosition = " ( " + m_Movement.getDestination().x + " , " + m_Movement.getDestination().y + " , " + m_Movement.getDestination().z + " ) "; 
						AddTask(CTask.TASK_GOTO_POSITION, getAID(), sNewPosition, m_CurrentTask.getPriority() + 1);
						break;
					}
				}
			}	
		}

	}
	/////////////////////////////////////////////////////////////////////////////////////////////////////
	
	/////////////////////////////////////////////////////////////////////////////////////////////////////
	/**
	 * Action to do when ammo or health values exceed the threshold allowed. 
	 * 
	 * This method is called when current values of ammo and health exceed the threshold allowed. These values are checked 
	 * by <tt> Launch_MedicAmmo_RequestBehaviour</tt> behaviour, every ten seconds. Perhaps it is convenient to create a 
	 * <tt> TASK_RUN_AWAY</tt> task.  
	 *   
	 * <em> It's very useful to overload this method. </em>
	 *   
	 */
	protected void PerformThresholdAction() {
		/*
		GenerateEscapePosition();
		String sNewPosition = " ( " + m_Movement.getDestination().x + " , " + m_Movement.getDestination().y + " , " + m_Movement.getDestination().z + " ) "; 
		AddTask(CTask.TASK_RUN_AWAY, getAID(), sNewPosition, m_CurrentTask.getPriority() + 1);
		*/
	}
	/////////////////////////////////////////////////////////////////////////////////////////////////////


	/////////////////////////////////////////////////////////////////////////////////////////////////////
	/**
	 * Action to do when this agent reaches the target of current task. 
	 * 
	 * This method is called when this agent goes to state <em>TARGET_REACHED</em>. If current task is <tt> TASK_GIVE_MEDICPAKS</tt>, 
	 * agent must give medic packs, but in other case, it calls to parent's method.
	 *   
	 * <em> It's very useful to overload this method. </em>
	 *   
	 * @param _CurrentTask
	 * 
	 */
	protected void PerformTargetReached(CTask _CurrentTask) {
		//log.writeLine(m_AStarPath.length);
		//log.writeLine("m_iAStarPathIndex antes"+m_iAStarPathIndex);
		switch ( _CurrentTask.getType() ) {
		case CTask.TASK_WALKING_PATH:
			if (m_eTeam == TEAM_ALLIED){
				//Ahora m_iAStarPathIndex es el ltimo ndice alcanzado
				if (operationState == GOING_HELL){
					switch (soldierState){
					case AT_WORK:
						//log.writeLine("AT_WORK");
						//log.writeLine("m_iAStarPathIndex (rear):"+m_iAStarPathIndex);
						//Voy construyendo una ruta que desanda el camino alcanzado ms reciente hacia la retaguardia
						if (lastValidRearIndex<BREAK_LENGTH-1){
							lastValidRearIndex++;
						}
						rearPath[4] = rearPath[3];
						rearPath[3] = rearPath[2];
						rearPath[2] = rearPath[1];
						rearPath[1] = rearPath[0];
						rearPath[0] = new Vector3D(hellPath[m_iAStarPathIndex]);
						super.PerformTargetReached(_CurrentTask);
						break;
					case TAKING_BREAK:
						//log.writeLine("TAKING_BREAK");
						//log.writeLine("m_iAStarPathIndex (rear):"+m_iAStarPathIndex);
						if (m_iAStarPathIndex==lastValidRearIndex){
							//Se acabo mi permiso, vuelvo al trabajo
							super.PerformTargetReached(_CurrentTask);
							m_AStarPath = hellPath;
							log.writeLine("Uso toHellPathIndex:"+toHellPathIndex);
							m_iAStarPathIndex = toHellPathIndex - lastValidRearIndex;
							//m_iAStarPathIndex = toHellPathIndex - (BREAK_LENGTH - 1);
							String sNewPosition = " ( " + m_AStarPath[m_iAStarPathIndex].x + " , " + 0 + " , " + m_AStarPath[m_iAStarPathIndex].z + " ) "; 
							AddTask(CTask.TASK_WALKING_PATH, getAID(), sNewPosition, m_TaskPriority[CTask.TASK_WALKING_PATH]);
							soldierState = AT_WORK;
							lastValidRearIndex = -1;
							log.writeLine("CHANGE STATE 19");
						}
						else{
							super.PerformTargetReached(_CurrentTask);
						}
						break;
					default:
						super.PerformTargetReached(_CurrentTask);
						break;
					}
				}
				else {
					super.PerformTargetReached(_CurrentTask);
				}
			}
			else{
				super.PerformTargetReached(_CurrentTask);
			}
			break;
		case CTask.TASK_GOTO_POSITION:
			super.PerformTargetReached(_CurrentTask);
			//log.writeLine("PerformTargetReached:TASK_GOTO_POSITION");		
			break;
		case CTask.TASK_GET_OBJECTIVE:
			super.PerformTargetReached(_CurrentTask);
			//log.writeLine("PerformTargetReached:TASK_GET_OBJECTIVE");		
			break;
		case CTask.TASK_NONE:
			super.PerformTargetReached(_CurrentTask);
			break;
		case CTask.TASK_GIVE_MEDICPAKS:
			super.PerformTargetReached(_CurrentTask);
			break;
		case CTask.TASK_STOP_WALKING:
			log.writeLine("TASK_STOP_WALKING");
			super.PerformTargetReached(_CurrentTask);
			break;
		default:
			super.PerformTargetReached(_CurrentTask);
			break;
		}
	}
	
	/////////////////////////////////////////////////////////////////////////////////////////////////////
	/**
	 * Decides if agent accepts the CFM request 
	 * 
	 * This method is a decision function invoked when a CALL FOR MEDIC request has arrived.
	 * Parameter <tt> sContent</tt> is the content of message received in <tt> CFM</tt> responder behaviour as
	 * result of a <tt> CallForMedic</tt> request, so it must be: <tt> ( x , y , z ) ( health ) </tt>.
	 * By default, the return value is <tt> TRUE</tt>, so agents always accept all CFM requests.
	 *   
	 * <em> It's very useful to overload this method. </em>
	 *   
	 * @param _sContent
	 * @return <tt> TRUE</tt> 
	 * 
	 */
	protected boolean checkMedicAction(String _sContent) {
		if (m_CurrentTask.getType()!=CTask.TASK_GIVE_MEDICPAKS){
			StringTokenizer tokens = new StringTokenizer(_sContent);
			tokens.nextToken();
			double x = Double.parseDouble(tokens.nextToken());
			tokens.nextToken();
			double y = Double.parseDouble(tokens.nextToken());
			tokens.nextToken();
			double z = Double.parseDouble(tokens.nextToken());
			if (CheckStaticPosition(x, z)){
				log.writeLine("VOOOOY!!!");
				return ( true );
			}
			else {
				log.writeLine("DEMASIADO LEJOS!!!");
				return ( false );
			}
		}
		else {
			log.writeLine("YA ESTOY ATENDIENDO!!!");
			return ( false );
		}
	}
	/////////////////////////////////////////////////////////////////////////////////////////////////////
	
	
	protected void takeDown(){
		try{
			DFService.deregister(this);
		}
		catch (FIPAException fe){
			fe.printStackTrace();
		}
		if (m_eTeam == TEAM_ALLIED) {
			if (gotFlag){
				DFAgentDescription dfag = new DFAgentDescription();
				if (pals!=null){
					int i = pals.length-1;
					//Si hay alguien ms aparte de mi le envio el ndice de la homePath al que voy
					if (i>1){
						ACLMessage gf_msg = new ACLMessage(ACLMessage.INFORM);
						do{
							DFAgentDescription pal = pals[i--];
							AID palAID = pal.getName();
							//No me envo la posicin a mi mismo
							if (palAID.equals(getName())) continue;
							gf_msg.addReceiver(palAID);
						}while (i>=0);
						gf_msg.setContent("");
						gf_msg.setConversationId(LOST_FLAG);
						send(gf_msg);
						return;	
					}
				}
			}
		}
		else {

		}
	}
}



